(in-package "DEDUC")

(eval-when (:compile-toplevel :load-toplevel :execute)
   (import '(mcdermott:perform-test mcdermott:test-check)))

(define (domain sym)
   (:requirements :chaining)
   (:predicates (same-as ?ying ?yang))
   (:constants morning-star evening-star)
   (:timeless (same-as morning-star evening-star))
    
   (:axiom
       :vars (?x ?y)
       :implies (-> (same-as ?x ?y) (same-as ?y ?x))))


(define (domain test)
   (:extends sym)
   (:requirements :chaining)
   (:predicates (foo ?x - object)
		(baz ?x - object)
		(wow ?x - object)
		(foz ?x - object)
		(loves ?x ?y))
   (:axiom
       :vars (?y)
       :context (foo ?y)
       :implies (-> (baz ?y) (wow ?y))))

(define (context con1)
    (:domain test)
    (:objects a1 b1 - object)
    (:init (foo a1)
	   (baz a1)
	   (freevars (?x ?y)
	      (<- (loves ?x ?y)
		  (same-as ?x ?y)))))


(defvar con1)

(defvar dom1)

(perform-test "Initialization"
   (setq dom1 (domain-initialize 'test))
   (indexed-domain-make-current dom1)
   (setq con1 (find-named-context 'con1 dom1)))

(perform-test "Basic backward chaining"
   (let ((a (deduce '(wow ?x) 1 nil con1 dom1)))
      (test-check
	  (equal (one-bindings-subst a 1)
		 '((x a1)))
	  "Failed basic backward chaining ~x" a)))

(perform-test "Timeless chaining"
   (test-check
      (not (null (deduce '(loves morning-star evening-star)
			 1 '() con1 dom1)))
      "Failed timeless chaining"))


    